﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace AutoScrolling_121520
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
         
            var timer = new DispatcherTimer { Interval = TimeSpan.FromMilliseconds(500) };
            timer.Tick += timer_Tick;
            timer.Start();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            var view = this.DataContext as ViewModel;
            var date = new DateTime(2015, 1, 1);
            view.DataPoints.Add(new Model()
            {
                XData = date.AddYears(1),
                High = new Random().Next(80, 150),
                Low = new Random().Next(60, 100),
                Open = new Random().Next(100, 200),
                Close = new Random().Next(120, 180)
            });
        }

        //ActualRangeChanged is an event, used to change the axis visble range.

        private void CategoryAxis_ActualRangeChanged(object sender, Syncfusion.UI.Xaml.Charts.ActualRangeChangedEventArgs e)
        {
            if (e.IsScrolling) return;
            // To Change the X-Axis visible range by using the VisibleMaximum and VisibleMinimum property.
            e.VisibleMinimum = Convert.ToDouble(e.ActualMaximum)-10;
        }

        private void NumericalAxis_ActualRangeChanged(object sender, Syncfusion.UI.Xaml.Charts.ActualRangeChangedEventArgs e)
        {
            // To Change the Y-Axis visible range by using the VisibleMaximum and VisibleMinimum property.
            e.VisibleMinimum = (double)e.ActualMinimum + 20;
        }
    }

    public class Model
    {
        public DateTime XData
        {
            get;
            set;
        }
        public double High
        {
            get;
            set;
        }

        public double Low
        {
            get;
            set;
        }

        public double Open
        {
            get;
            set;
        }

        public double Close
        {
            get;
            set;
        }
    }

    public class ViewModel
    {
        public ObservableCollection<Model> DataPoints
        {
            get;
            set;
        }
        public ViewModel()
        {

            this.DataPoints = new ObservableCollection<Model>();
            var date = new DateTime(2010, 1, 1);
            DataPoints.Add(new Model { XData = date.AddYears(1), High = 80, Low = 50, Open = 60, Close = 80 });
            DataPoints.Add(new Model { XData = date.AddYears(2), High = 100, Low = 90, Open = 120, Close = 140 });
            DataPoints.Add(new Model { XData = date.AddYears(3), High = 100, Low = 80, Open = 100, Close = 130 });
            DataPoints.Add(new Model { XData = date.AddYears(4), High = 120, Low = 100, Open = 140, Close = 160 });
            DataPoints.Add(new Model { XData = date.AddYears(5), High = 80, Low = 50, Open = 60, Close = 80 });
        }
    }
}
